﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Security.Cryptography;
using System.Xml;
using System.IO;
using System.Net;

namespace webcti
{
    public partial class frm_main : Form
    {
        public frm_main()
        {
            InitializeComponent();
            init_listview_cpu();
            init_listview_user();
            init_listview_device();
            init_listview_queue();
        }
        private void init_listview_public(ListView lv_var)
        {
            //更改属性
            lv_var.GridLines = true;
            //显示表格线
            lv_var.View = View.Details;
            //显示表格细节
            // lv_var.LabelEdit = true;
            //有滚动条
            lv_var.HeaderStyle = ColumnHeaderStyle.Clickable;
            //对表头进行设置
            lv_var.FullRowSelect = true;
        }
        private void init_listview_cpu()
        {
            init_listview_public(lv_cpu);
            //添加表头            
            lv_cpu.Columns.Add("项目", 60, HorizontalAlignment.Center);
            lv_cpu.Columns.Add("值", 130, HorizontalAlignment.Right);   
        }
        private void init_listview_user()
        {
            init_listview_public(lv_user);
            //添加表头            
            lv_user.Columns.Add("项目", 80, HorizontalAlignment.Center);
            lv_user.Columns.Add("值", 80, HorizontalAlignment.Left);
        }
        private void init_listview_device()
        {
            init_listview_public(lv_device);
            //添加表头            
            lv_device.Columns.Add("项目", 80, HorizontalAlignment.Center);
            lv_device.Columns.Add("值", 120, HorizontalAlignment.Left);
        }
        private void init_listview_queue()
        {
            init_listview_public(lv_queue);
            //添加表头            
            lv_queue.Columns.Add("坐席", 120, HorizontalAlignment.Center);
            lv_queue.Columns.Add("工号", 60, HorizontalAlignment.Left);
            lv_queue.Columns.Add("类型", 60, HorizontalAlignment.Left);
             lv_queue.Columns.Add("惩罚值", 60, HorizontalAlignment.Left);
             lv_queue.Columns.Add("接听数", 60, HorizontalAlignment.Left);
             lv_queue.Columns.Add("状态", 60, HorizontalAlignment.Left);
             lv_queue.Columns.Add("示忙", 60, HorizontalAlignment.Left);
            
        }
    
        private string  get_stattuscomment(string strstattus)
        {
            if (strstattus == null || strstattus.Length == 0)
                return "未知";
            int stattus = Convert.ToInt32(strstattus);
            switch (stattus)
            {
                case -2: return "移除";
                    case -1: return "未激活";
                    case 0: return "空闲";
                    case 1: return "使用";
                    case 2: return "忙";
                    case 4: return "不可用";
                    case 8: return "振铃";
                    case 9: return "使用";
            }
            return "";
        } 
        private XmlDocument get_ctixml(string url) {
            XmlDocument doc = new XmlDocument();
             HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
             request.UnsafeAuthenticatedConnectionSharing = true;
             request.Method = "GET";
             request.Timeout = 5000;
             // Downloads the XML file from the specified server.
             try
             {
                 HttpWebResponse response = (HttpWebResponse)request.GetResponse();
                 StreamReader sr = new StreamReader(response.GetResponseStream(), System.Text.Encoding.GetEncoding("gb2312"));
                String retXml = sr.ReadToEnd();
                sr.Close();
                doc.LoadXml(retXml);
                response.Close();
             }
             catch (Exception exc)
             {
                 System.Diagnostics.Debug.WriteLine(exc.StackTrace);
                 MessageBox.Show(exc.Message);
             }
             return doc;            
        }
        private string get_xmlvalue( XmlNode Node,string feild) {

            XmlNode xn = Node.SelectSingleNode(feild);
            if (xn == null || xn.FirstChild ==null)
                return "";
            else
            {
                return xn.FirstChild.Value;
            }                
        }
        private Boolean  check_textbox(TextBox tb,string msg)
        {
            if (tb.Text.Length == 0) {
                MessageBox.Show(msg);
                tb.Focus();
                return false;
            }
            return true;
        }
         private string get_webkey()
        {

            string strResult="";
            string mvbwebkey = "";
            DateTime currentTime = DateTime.Now;
            mvbwebkey = tb_webkey.Text;
            if (mvbwebkey.Length == 0)
            {
                MessageBox.Show("请输入MVB2000平台的WEB密钥!");
                tb_webkey.Focus();
            }
             MD5 md5=MD5.Create();
             mvbwebkey = mvbwebkey + currentTime.ToString("yyyy-MM-dd");
             
             byte[] bytResult = md5.ComputeHash(System.Text.Encoding.ASCII.GetBytes(mvbwebkey));
            for (int i = 0; i <bytResult.Length; i++){

                string hexOutput = String.Format("{0:x2}", bytResult[i]);

                strResult = strResult + hexOutput;
　　  }
            md5.Clear();
            tb_key.Text = strResult;
　　  return strResult;
        }
        /*获取设备拨号接口*/
        private string  get_interface(string strdevice)
        {
            string url;
            
            string webkey = get_webkey();
            if (webkey.Length == 0) return null;
            url = tb_web.Text + "/webservice/ctigetdevice.php?webkey=" + webkey + "&device=" + strdevice;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return null;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return null;
            if (Convert.ToInt32(get_xmlvalue(row, "errcode")) == 0)
            {
               return  get_xmlvalue(row, "dial");
            }
            return null;
            
        }
        /*获取拨号授权*/
        private string get_context(string strdevice)
        {
            string url;

            string webkey = get_webkey();
            if (webkey.Length == 0) return null;
            url = tb_web.Text + "/webservice/ctigetdevice.php?webkey=" + webkey + "&device=" + strdevice;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return null;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return null;
            if (Convert.ToInt32(get_xmlvalue(row, "errcode")) == 0)
            {
                return get_xmlvalue(row, "context");
            }
            return null;

        }
        /*获取活动通道*/
        private string get_channel(string strinterface)
        {
            string url;
            string strstate="";
            string strrefchannel = "";
            string strchannel = "";
            string webkey = get_webkey();
            if (webkey.Length == 0) return null;
            url = tb_web.Text + "/webservice/getchannel.php?webkey=" + webkey + "&channel=" + strinterface + "&refchannel=" + strinterface;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return null;
            for (int i = 0; i < nodelist.Count; i++) { 
                XmlNode row = nodelist.Item(i);
                strstate = get_xmlvalue(row, "state");
                if (strstate == "Hangup") continue;
                strchannel = get_xmlvalue(row, "channel");
                if (strchannel.StartsWith(strinterface + "-")) return strchannel;
                strrefchannel = get_xmlvalue(row, "refchannel");
                if (strrefchannel.StartsWith(strinterface + "-")) return strrefchannel;
                
            }
            return null;

        }
        /*获取对方活动通道*/
        private string get_refchannel(string strinterface)
        {
            string url;
            string strstate = "";
            string strrefchannel = "";
            string strchannel = "";
            string webkey = get_webkey();
            if (webkey.Length == 0) return null;
            url = tb_web.Text + "/webservice/getchannel.php?webkey=" + webkey + "&channel=" + strinterface + "&refchannel=" + strinterface;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return null;
            for (int i = 0; i < nodelist.Count; i++)
            {
                XmlNode row = nodelist.Item(i);
                strstate = get_xmlvalue(row, "state");
                if (strstate == "Hangup") continue;
                strchannel = get_xmlvalue(row, "channel");
                if (strchannel.StartsWith(strinterface + "-")) return strrefchannel;
                strrefchannel = get_xmlvalue(row, "refchannel");
                if (strrefchannel.StartsWith(strinterface + "-")) return strchannel;

            }
            return null;

        }
        /*获取弹屏数据*/
        private string get_popup(string strinterface)
        {
            string url;
            string strout = null;
            string webkey = get_webkey();
            if (webkey.Length == 0) return null;
            url = tb_web.Text + "/webservice/getpopupscreen.php?webkey=" + webkey + "&channel=" + strinterface;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return null;
             XmlNode row = nodelist.Item(0);
            string  strchannel = get_xmlvalue(row, "channel");
            string struniqueid = get_xmlvalue(row, "uniqueid");
            string strcallerid = get_xmlvalue(row, "callerid");
            string strdirect = get_xmlvalue(row, "direct");
            strout = "电话号码:" + strcallerid + "\r\n";
            strout += "呼叫编号:" + struniqueid + "\r\n";
            strout += "活动通道:" + strchannel + "\r\n";
            strout += "方向:" + strdirect;
            return strout;

        }
        /*获取设备状态*/
        private string get_devicestatus(string strdevice)
        {
            string url;
            string webkey = get_webkey();
            if (webkey.Length == 0) return null;
            url = tb_web.Text + "/webservice/getextensionstatus.php?webkey=" + webkey + "&exten=" + strdevice;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return null;
            XmlNode row = nodelist.Item(0);
            return get_xmlvalue(row, "status");

        }
        /*CPU负载*/
        private void button1_Click(object sender, EventArgs e)
        {
            string url;
             if (!check_textbox(tb_web, "请输入WEB地址!") )
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            url = tb_web.Text + "/webservice/getcpuload.php?webkey=" + webkey;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist=xmldoc.GetElementsByTagName("row");
             if (nodelist==null || nodelist.Count == 0)return ;
             XmlNode row = nodelist.Item(0);
            int feildsnum=row.ChildNodes.Count;
            if (feildsnum<6) return;

            lv_cpu.BeginUpdate();
            lv_cpu.Items.Clear();           
           
             XmlNode xn = nodelist.Item(0);
             lv_cpu.Items.Add( new ListViewItem(new string[] { "采样时间", get_xmlvalue(row,"createtime")}));
             lv_cpu.Items.Add( new ListViewItem(new string[] { "用户", get_xmlvalue(row, "user")+"%" }));
             lv_cpu.Items.Add(new ListViewItem(new string[] { "系统", get_xmlvalue(row, "system") + "%" }));
             lv_cpu.Items.Add(new ListViewItem(new string[] { "后台", get_xmlvalue(row, "nice") + "%" }));
             lv_cpu.Items.Add(new ListViewItem(new string[] { "空闲", get_xmlvalue(row, "idle") + "%" }));
     
            lv_cpu.EndUpdate();
        }
        /*绑定*/
        private void button2_Click(object sender, EventArgs e)
        {
            string struser, strdevice;
            string url;
            
            if (!check_textbox(tb_web , "请输入WEB地址!") ||  !check_textbox(tb_user, "请输入用户号!") || !check_textbox(tb_device, "请输入设备号!"))
                return;
            string webkey=get_webkey();
            if (webkey.Length ==0 )return ;
            struser = tb_user.Text;
            strdevice = tb_device.Text;
            url = tb_web.Text + "/webservice/ctibinddevice.php?webkey=" + webkey + "&extension=" + struser + "&device=" + strdevice;
            XmlDocument xmldoc= get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist==null || nodelist.Count == 0)return ;
            XmlNode row = nodelist.Item(0);
            int feildsnum=row.ChildNodes.Count;
            if (feildsnum<2) return;            
            if ( Convert.ToInt32(get_xmlvalue(row,"errcode"))==0)
                MessageBox.Show("绑定成功:"+get_xmlvalue(row, "errmsg"));
            else
                MessageBox.Show("绑定失败:" + get_xmlvalue(row, "errmsg"));

            button10_Click(sender, e);
            button11_Click(sender, e);
            
        }
 
        /*队列信息*/
        private void button9_Click(object sender, EventArgs e)
        {
            string url;
            if (!check_textbox(tb_web, "请输入WEB地址!") || !check_textbox(tb_queue, "请输入队列号!"))
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            url = tb_web.Text + "/webservice/getqueuemember.php?webkey=" + webkey + "&queue=" + tb_queue.Text;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
             int feildsnum =0;
             lv_queue.BeginUpdate();
            lv_queue.Items.Clear();
            for (int i = 0; i < nodelist.Count;i++ )
            {
                XmlNode row = nodelist.Item(i);
                feildsnum = row.ChildNodes.Count;
                if (feildsnum < 2) continue;
                XmlNode xn = nodelist.Item(i);
                lv_queue.Items.Add(new ListViewItem(new string[] {  get_xmlvalue(row, "agent"), get_xmlvalue(row, "agentname") 
                    , get_xmlvalue(row, "agentship") , get_xmlvalue(row, "penalty") , get_xmlvalue(row, "callstaken")
                    , get_xmlvalue(row, "status"), get_xmlvalue(row, "paused") }));
            }
            //if (((i + 1) % 2) == 0) lvi.SubItems[0].BackColor = Color.LightYellow;
            lv_queue.EndUpdate();
        }
        private void frm_main_Load(object sender, EventArgs e)
        {

        }
        /*用户信息*/
        private void button10_Click(object sender, EventArgs e)
        {
            string url;
            if (!check_textbox(tb_web, "请输入WEB地址!")  ||  !check_textbox(tb_user, "请输入用户号!") )
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            url = tb_web.Text + "/webservice/ctigetuser.php?webkey=" + webkey+"&user="+tb_user.Text ;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return;
            if ( Convert.ToInt32(get_xmlvalue(row,"errcode"))>0){
                MessageBox.Show("错误:"+get_xmlvalue(row, "errmsg"));
            }
            lv_user.BeginUpdate();
            lv_user.Items.Clear();
            
            XmlNode xn = nodelist.Item(0);
            lv_user.Items.Add(new ListViewItem(new string[] { "用户名称", get_xmlvalue(row, "cidcnname") }));
            lv_user.Items.Add(new ListViewItem(new string[] { "来显名称", get_xmlvalue(row, "cidname") }));
            lv_user.Items.Add(new ListViewItem(new string[] { "绑定设备", get_xmlvalue(row, "device")  }));
            lv_user.Items.Add(new ListViewItem(new string[] { "彩铃", get_xmlvalue(row, "musichold")  }));
            lv_user.Items.Add(new ListViewItem(new string[] { "出局号码", get_xmlvalue(row, "outboundcid") }));
             lv_user.Items.Add(new ListViewItem(new string[] { "振铃时长", get_xmlvalue(row, "ringtimer") }));
             lv_user.Items.Add(new ListViewItem(new string[] { "语音信箱", get_xmlvalue(row, "voicemail") }));
            
            //if (((i + 1) % 2) == 0) lvi.SubItems[0].BackColor = Color.LightYellow;
            lv_user.EndUpdate();
        }
        /*设备信息*/
        private void button11_Click(object sender, EventArgs e)
        {
            string url;
            if (!check_textbox(tb_web, "请输入WEB地址!") || !check_textbox(tb_user, "请输入用户号!"))
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            url = tb_web.Text + "/webservice/ctigetdevice.php?webkey=" + webkey + "&device=" + tb_device.Text;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return;
            if (Convert.ToInt32(get_xmlvalue(row, "errcode")) > 0)
            {
                MessageBox.Show("错误:" + get_xmlvalue(row, "errmsg"));
            }
            lv_device.BeginUpdate();
            lv_device.Items.Clear();
           
            XmlNode xn = nodelist.Item(0);
            lv_device.Items.Add(new ListViewItem(new string[] { "名称", get_xmlvalue(row, "cnname") }));
            lv_device.Items.Add(new ListViewItem(new string[] { "设备类型", get_xmlvalue(row, "type") }));
            lv_device.Items.Add(new ListViewItem(new string[] { "绑定用户", get_xmlvalue(row, "user") }));
            lv_device.Items.Add(new ListViewItem(new string[] { "拨号授权", get_xmlvalue(row, "context") }));
            lv_device.Items.Add(new ListViewItem(new string[] { "拨号接口", get_xmlvalue(row, "dial") }));

            //if (((i + 1) % 2) == 0) lvi.SubItems[0].BackColor = Color.LightYellow;
            lv_device.EndUpdate();
        }
        /*分离*/
        private void button3_Click(object sender, EventArgs e)
        {
            string struser, strdevice;
            string url;
           
            if (!check_textbox(tb_web, "请输入WEB地址!") || !check_textbox(tb_user, "请输入用户号!") || !check_textbox(tb_device, "请输入设备号!"))
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            struser = tb_user.Text;
            strdevice = tb_device.Text;
            url = tb_web.Text + "/webservice/ctisplitdevice.php?webkey=" + webkey + "&extension=" + struser + "&device=" + strdevice;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return;
            if (Convert.ToInt32(get_xmlvalue(row, "errcode")) == 0)
                MessageBox.Show("分离成功:" + get_xmlvalue(row, "errmsg"));
            else
                MessageBox.Show("分离失败:" + get_xmlvalue(row, "errmsg"));

            button10_Click(sender,  e);
            button11_Click(sender, e);
            


        }
        /*登入队列*/
        private void button4_Click(object sender, EventArgs e)
        {
            string strqueue, strdevice;
            string url;
            
            if (!check_textbox(tb_web, "请输入WEB地址!") || !check_textbox(tb_queue, "请输入队列号!") || !check_textbox(tb_device, "请输入设备号!"))
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            strqueue = tb_queue.Text;
            strdevice = tb_device.Text;
            string strinterface = get_interface(strdevice);
            if (strinterface == null) {
                MessageBox.Show("获取设备" + strdevice + "拨号接口失败!");
                return;
            }
            url = tb_web.Text + "/webservice/ctiqueueadd.php?webkey=" + webkey + "&queue=" + strqueue + "&interface=" +strinterface;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return;
            if (get_xmlvalue(row, "Response")=="Success")
                MessageBox.Show("成功:" + get_xmlvalue(row, "Message"));
            else
                MessageBox.Show("失败:" + get_xmlvalue(row, "Message"));

            
            button9_Click(sender, e);
            
        }
        /*登出队列*/
        private void button5_Click(object sender, EventArgs e)
        {
            string strqueue, strdevice;
            string url;
            
            if (!check_textbox(tb_web, "请输入WEB地址!") || !check_textbox(tb_queue, "请输入队列号!") || !check_textbox(tb_device, "请输入设备号!"))
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            strqueue = tb_queue.Text;
            strdevice = tb_device.Text;
            string strinterface = get_interface(strdevice);
            if (strinterface == null)
            {
                MessageBox.Show("获取设备" + strdevice + "拨号接口失败!");
                return;
            }
            url = tb_web.Text + "/webservice/ctiqueueremove.php?webkey=" + webkey + "&queue=" + strqueue + "&interface=" + strinterface;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return;
            if (get_xmlvalue(row, "Response") == "Success")
                MessageBox.Show("成功:" + get_xmlvalue(row, "Message"));
            else
                MessageBox.Show("失败:" + get_xmlvalue(row, "Message"));
            button9_Click(sender, e);
        }

        /*坐席示忙*/
        private void button6_Click(object sender, EventArgs e)
        {
            string strqueue, strdevice;
            string url;
           
            if (!check_textbox(tb_web, "请输入WEB地址!") || !check_textbox(tb_queue, "请输入队列号!") || !check_textbox(tb_device, "请输入设备号!"))
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            strqueue = tb_queue.Text;
            strdevice = tb_device.Text;
            string strinterface = get_interface(strdevice);
            if (strinterface == null)
            {
                MessageBox.Show("获取设备" + strdevice + "拨号接口失败!");
                return;
            }
            url = tb_web.Text + "/webservice/ctiqueuepause.php?webkey=" + webkey + "&queue=" + strqueue + "&interface=" + strinterface + "&paused=true";
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return;
            if (get_xmlvalue(row, "Response") == "Success")
                MessageBox.Show("成功:" + get_xmlvalue(row, "Message"));
            else
                MessageBox.Show("失败:" + get_xmlvalue(row, "Message"));
            button9_Click(sender, e);
        }

        /*坐席示闲*/
        private void button7_Click(object sender, EventArgs e)
        {
            string strqueue, strdevice;
            string url;
           
            if (!check_textbox(tb_web, "请输入WEB地址!") || !check_textbox(tb_queue, "请输入队列号!") || !check_textbox(tb_device, "请输入设备号!"))
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            strqueue = tb_queue.Text;
            strdevice = tb_device.Text;
            string strinterface = get_interface(strdevice);
            if (strinterface == null)
            {
                MessageBox.Show("获取设备" + strdevice + "拨号接口失败!");
                return;
            }
            url = tb_web.Text + "/webservice/ctiqueuepause.php?webkey=" + webkey + "&queue=" + strqueue + "&interface=" + strinterface + "&paused=false";
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return;
            if (get_xmlvalue(row, "Response") == "Success")
                MessageBox.Show("成功:" + get_xmlvalue(row, "Message"));
            else
                MessageBox.Show("失败:" + get_xmlvalue(row, "Message"));
            button9_Click(sender, e);
        }

        /*拨号*/
        private void button8_Click(object sender, EventArgs e)
        {
            string strphone, strdevice;
            string url;
           
            if (!check_textbox(tb_web, "请输入WEB地址!") || !check_textbox(tb_phone, "请输入号码!") || !check_textbox(tb_device, "请输入设备号!"))
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            strphone = tb_phone.Text;
            strdevice = tb_device.Text;
            string strinterface = get_interface(strdevice);
            if (strinterface == null)
            {
                MessageBox.Show("获取设备" + strdevice + "拨号接口失败!");
                return;
            }
            string strchannel = get_interface(strdevice);
            string strcontext = get_context(strdevice);
            string strexten = strphone;
            string strpriority = "1";
            string strtimeout = "30000";
            string strcallerid = strphone;
            string strasync = "yes";
            string strvariable="FIRSTEXTCALLER="+tb_user.Text +"|MVB_CALLER="+tb_user.Text +"|MVB_CALLEE="+strexten+"|MVB_DIRECT=OUT";
            url = tb_web.Text + "/webservice/ctioriginate.php?webkey=" + webkey + "&channel=" + strchannel + "&context=" + strcontext + "&exten=" + strexten + "&priority=" + strpriority + "&strcallerid=" + strcallerid + "&timeout" + strtimeout + "&variable=" + strvariable + "&async=" + strasync;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return;
            if (get_xmlvalue(row, "Response") == "Success")
                MessageBox.Show("成功:" + get_xmlvalue(row, "Message"));
            else
                MessageBox.Show("失败:" + get_xmlvalue(row, "Message"));
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            string strstatus=null;
            string strdevice=tb_device.Text;
            string strinterface;
            string strpopup;
            button1_Click(sender, e);
            if (strdevice.Length > 0)
            {
                strstatus = get_stattuscomment(get_devicestatus(strdevice));                

            }
            if (strstatus != null)
            {
                lbl_status.Text = strstatus;
                strinterface=get_interface(strdevice);
                if(strinterface!=null && strinterface!=""){
                    strpopup = get_popup(strinterface);
                    if (strpopup != null) tb_popup.Text = strpopup;
                }
            }

        }
        /*拆线*/
        private void button12_Click(object sender, EventArgs e)
        {
            string strchannel, strdevice, strinterface;
            string url;
           
            if (!check_textbox(tb_web, "请输入WEB地址!")  || !check_textbox(tb_device, "请输入设备号!"))
                return;
            string webkey = get_webkey();
            if (webkey.Length == 0) return;
            
            strdevice = tb_device.Text;
            strinterface = get_interface(strdevice);
            if (strinterface == null || strinterface == "") return;
            strchannel = get_channel(strinterface);
            if (strchannel == null || strchannel == "") return;
            url = tb_web.Text + "/webservice/ctihangup.php?webkey=" + webkey + "&channel=" + strchannel ;
            XmlDocument xmldoc = get_ctixml(url);
            XmlNodeList nodelist = xmldoc.GetElementsByTagName("row");
            if (nodelist == null || nodelist.Count == 0) return;
            XmlNode row = nodelist.Item(0);
            int feildsnum = row.ChildNodes.Count;
            if (feildsnum < 2) return;
            if (get_xmlvalue(row, "Response") == "Success")
                MessageBox.Show("成功:" + get_xmlvalue(row, "Message"));
            else
                MessageBox.Show("失败:" + get_xmlvalue(row, "Message"));

        }

        private void button13_Click(object sender, EventArgs e)
        {

            if (button13.Text == "监控来电")
            {
                timer1.Start();
                button13.Text = "停止监控";
            } else {
                timer1.Stop();
                button13.Text = "监控来电";
            }
            
            
        }
 
    }
}